// Copyright (C) 2002 Christian Weis
//
// this is just an example of demonstrating the working 
// of function guarding and how to use it in your projects.
//
// i use MS VC++ 6.0 and it works fine :)
//
// you may get some warnings that some code is unreachable or something else.
// you can simply disable it with:
// #pragma warning (disable: 4702) // unreachable source code

// own includes
#include "ErrHandler.h"

// compiler includes
#define WIN32_LEAN_AND_MEAN
#define VC_EXTRALEAN
#define WIN32_EXTRALEAN

#include <windows.h>
#include <windowsx.h>

// a time critical func :)
static unsigned TimeCriticalFunc (unsigned a)
	GUARD_FAST (TimeCriticalFunc)
	return 12 / a;
	UNGUARD_FAST

// does anything
static bool DoAnyInitHere ()
	GUARD (DoAnyInitHere)

	// ...

	THROW ("Damn thing!")

	// ...

	return false;
	UNGUARD

// inits app
void AppInit ()
	GUARD (AppInit)

	// ...

	if (!DoAnyInitHere ())
		THROW ("Init failed!")

	// ...

	UNGUARD

// uninits app
void AppUninit ()
	GUARD (AppUninit)

	// ...

	THROW ("Uninit failed badly!")

	// ...

	UNGUARD

// runs app
void AppRun ()
	GUARD (AppRun)

	// ...

	// call this one
	int a = TimeCriticalFunc (0);
	a;

	// ...

	UNGUARD

// app cleanup after err
void AppErr ()
	GUARD (AppErr)

	// ...

	THROW ("Ops!")

	// ...

	UNGUARD

// enter app
int WINAPI WinMain (HINSTANCE, HINSTANCE, LPSTR, int)
{
	// this try/catch construct is needed here
	try
	{
		GUARD (WinMain)

		// call app
		AppInit ();
		AppRun ();
		AppUninit ();

		UNGUARD
	}

	catch (...)
	// exception handling
	{
		PROTECTED (apiDisableErrHandler ();)
		PROTECTED (AppErr ();)
		PROTECTED (apiShowErr ();)
		PROTECTED (AppUninit ();)
	}

	return 0;
}